#include <stdio.h>
#include <unistd.h>
#include "substfuncs.h"
#include "catchup.h"
#include "proto.h"

void
SUBSTfilename(arg, ret, len, parm)
    char *arg;
    char *ret;
    size_t len;
    FILT *parm;
{
    char *curfile = CUPgetfilename(parm);

    if (!curfile) {
        *ret = 0;
        return;
    }
    strncpy(ret, curfile, len);
    ret[len-1] = 0;
}

void
SUBSTfiletext(arg, ret, len, parm)
    char *arg;
    char *ret;
    size_t len;
    FILT *parm;
{
    FILE *f;
    char *curfile = CUPgetfilename(parm);

    if (!curfile) {
        *ret = 0;
        return;
    }
    f = fopen(curfile, "r");
    if (!f) {
        *ret = 0;
        return;
    }
    fread((void*)ret, 1, len, f);
    fclose(f);
}

size_t
SUBSTfilelen(arg, parm)
    char *arg;
    FILT *parm;
{
    FILE *f;
    size_t start, end;
    char *curfile = CUPgetfilename(parm);

    if (!curfile)
        return(0);
    f = fopen(curfile, "r");
    if (!f)
        return(0);
    fseek(f, 0, SEEK_SET);
    start = ftell(f);
    fseek(f, 0, SEEK_END);
    end = ftell(f);
    fclose(f);
    return(end-start);
}
