#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <string.h>
#include "filter.h"
#include "exec.h"
#include "subst.h"

void
NOTIFYsendmail(filt, cmdline, input)
    FILT *filt;
    char *cmdline;
    char *input;
{
    char **args;
    char *buf;
    size_t len;
    int pipeno[2];

    if (!cmdline)
        return;
    pipe(pipeno);
    switch (fork()) {
      case 0:
        close(0);
        dup2(pipeno[0], 0);
        close(pipeno[1]);
        len = SUBSTlengthtext(cmdline, filt);
        buf = (char*)malloc(len);
        if (!buf)
            exit(1);
        SUBSTchangetext(cmdline, buf, len, filt);
        args=(char**)malloc(sizeof(char*)*(EXECnumargs(buf)+1));
        EXECfillargs(args, buf);
        execv(args[0], args);
        /* not reached */

        fprintf(stderr, "Couldn't exec() %s\n", cmdline);
        exit(1);
      case -1:
        fprintf(stderr, "Couldn't fork() child process!\n");
        exit(1);
    }
    if (!input)
        return;
    len = SUBSTlengthtext(input, filt);
    buf = (char*)malloc(len);
    if (!buf)
        return;
    SUBSTchangetext(input, buf, len, filt);
    write(pipeno[1], buf, strlen(buf));
    write(pipeno[1], "\n", 1);
    close(pipeno[1]);
    free((void*)buf);
}
