#ifdef _AIX
#include <sys/file.h>
#endif

#include <ndbm.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>

#include "filtpaths.h"

typedef struct _datumlist {
    datum data;
    struct _datumlist *next;
} datumlist;

int main()
{
    DBM *d;
    datum data, numposts;
    datumlist *del=0, *iter;
    time_t curtime;
    int fd;
    int period;
    int err;
    struct tm *t;
    char keystr[256], poststr[12];

    if (!(fd = open(_PATH_POSTDB, O_RDWR))) return(1);
    flock(fd, LOCK_EX);
    if (!(d = dbm_open(_PATH_POSTDB, O_RDWR, 0660))) {
        flock(fd, LOCK_UN);
        close(fd);
        return(1);
    }
    time(&curtime);
    t = localtime(&curtime);
    period = t->tm_hour<12;	/* 1 for AM, 0 for PM */
    for (data = dbm_firstkey(d); data.dptr; data = dbm_nextkey(d)) {
        strncpy(keystr, data.dptr, data.dsize);
        data.dptr = keystr;
        numposts = dbm_fetch(d, data);
        strncpy(poststr, numposts.dptr, numposts.dsize);
        keystr[data.dsize] = 0;
        poststr[numposts.dsize] = 0;
        printf("Key %s posts %s", keystr, poststr);
        if (data.dptr[0] == (period?'A':'P')) {
            iter = (datumlist*)malloc(sizeof(datumlist));
            iter->data.dptr = (char*)malloc(data.dsize+1);
            strcpy(iter->data.dptr, keystr);
            iter->data.dsize = data.dsize;
            iter->next = del;
            del = iter;
            printf(" deleted");
        }
        printf(".\n");
    }
    for (iter = del; iter;) {
        if (dbm_delete(d, iter->data))
            fprintf(stderr, "Error deleting key: %s!\n", iter->data.dptr);
        free((void*)iter->data.dptr);
        iter = iter->next;
        free((void*)del);
        del = iter;
    }
    dbm_close(d);
    flock(fd, LOCK_UN);
    close(fd);
    return(0);
}
