#ifdef _AIX
#include <sys/file.h>
#endif

#include <ndbm.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>

#include "filtpaths.h"

int main()
{
    DBM *d;
    datum data, numposts;
    char datastr[256], numstr[20];
    time_t curtime;
    int fd;
    struct tm *t;

    if (!(fd = open(_PATH_POSTDB, O_RDWR))) return(1);
    flock(fd, LOCK_EX);
    if (!(d = dbm_open(_PATH_POSTDB, O_RDWR, 0660))) {
        flock(fd, LOCK_UN);
        close(fd);
        return(1);
    }
    time(&curtime);
    t = localtime(&curtime);
    for (data = dbm_firstkey(d); data.dptr; data = dbm_nextkey(d)) {
        strncpy(datastr, data.dptr, data.dsize);
        datastr[data.dsize] = 0;
        printf("Key %s ", datastr);
        data.dptr = datastr;
        numposts = dbm_fetch(d, data);
        strncpy(numstr, numposts.dptr, numposts.dsize);
        numstr[numposts.dsize] = 0;
        printf("posted %s times.\n", numstr);
    }
    dbm_close(d);
    flock(fd, LOCK_UN);
    close(fd);
    return(0);
}
