#ifndef __FILTER_H
#define __FILTER_H

#include <sys/types.h>
#include <stdio.h>
#include "config.h"

typedef struct _FILT {} FILT;

typedef void (*FILTdelfunc)(int, void*, size_t);

extern int FILTinit();
extern FILT *FILTconnect(FILT*);
extern FILT *FILTgetparent(FILT*);
extern void FILTdestroy(FILT*);
extern char *FILTgetuser(FILT*);
extern void FILTsetuser(FILT*, char*);

extern void FILTlogmessage(FILT*, char*, char*, char*);

extern CONF *FILTkeylist;

/* access data associated with a FILT */

#define kFILTinttype	-1
#define kFILTstrtype	-2
#define kFILTfiletype	-3
#define kFILTfilttype	-4

extern void FILTadddata(FILT*, int, char*, void*, size_t, int);
extern void *FILTgetdata(FILT*, int, char*, size_t*, int);
extern int FILThasdata(FILT*, int, char*, int);
extern void FILTdeldata(FILT*, int, char*, int);

extern void FILTaddstring(FILT*, char*, char*, int);
extern char *FILTgetstring(FILT*, char*, int);
extern int FILThasstring(FILT*, char*, int);
extern void FILTdelstring(FILT*, char*, int);

extern void FILTaddint(FILT*, char*, int, int);
extern int FILTgetint(FILT*, char*, int);
extern int FILThasint(FILT*, char*, int);
extern void FILTdelint(FILT*, char*, int);

extern void FILTaddfile(FILT*, char*, char*, FILE*, int);
extern FILE *FILTgetfile(FILT*, char*, int);
extern char *FILTgetfname(FILT*, char*, int);
extern int FILThasfile(FILT*, char*, int);
extern int FILTisopenfile(FILT*, char*, int);
extern void FILTclosefile(FILT*, char*, int);
extern void FILTdelfile(FILT*, char*, int);

extern void FILTaddfilt(FILT*, char*, FILT*, int);
extern FILT *FILTgetfilt(FILT*, char*, int);
extern int FILThasfilt(FILT*, char*, int);
extern void FILTdelfilt(FILT*, char*, int);

extern void FILTadddel(int, FILTdelfunc);

#endif
