#include <unistd.h>
#include <string.h>
#include <ctype.h>

/*
** Returns the number of arguments in a string passed in.  Doesn't do anywhere
** near as much globbing as system() would, but system fork()s and wait()s
** itself
*/
int
EXECnumargs(buf)
    char *buf;
{
    char quot=0;
    int pos, tot;

    tot=0;
    pos=0;
    while (buf[pos]) {
        if ((buf[pos] == '"')||(buf[pos] == '\'')) {
            quot=buf[pos++];
            while (buf[pos]&&(buf[pos] != quot))
                pos++;
            tot++;
        } else if (isspace(buf[pos])) {
            while (buf[pos]&&isspace(buf[pos]))
                pos++;
        } else {
            while (buf[pos]&&(!isspace(buf[pos])))
                pos++;
            tot++;
        }
    }
    return (tot);
}

/*
** Fills in the logical arguments in cmdline into the double array called
** args
*/

void
EXECfillargs(args, cmdline)
    char **args;
    char *cmdline;
{
    char *pos;
    char quot;
    char *store;
    int done=0;

    store=(char*)malloc(strlen(cmdline)+1);
    strcpy(store, cmdline);
    cmdline=store;

    pos=cmdline;
    while (*pos) {
        while (*cmdline&&isspace(*cmdline))
            cmdline++;
        pos=cmdline;
        if ((*pos=='"')||(*pos=='\'')) {
            cmdline++;
            quot=*pos++;
            while (*pos&&(*pos!=quot))
                pos++;
        } else
            while (*pos&&(!isspace(*pos)))
                pos++;
        if (!*pos)
            done=1;
        *pos=0;
        *args=(char*)malloc(strlen(cmdline)+1);
        strcpy(*args, cmdline);
        if (!done)
            cmdline=++pos;
        args++;
    }
    *args=0;
    free((void*)store);
}
