#include "authfuncs.h"

#if	defined(DO_AUTH_IDENT)

#include <ident.h>
#include <ndbm.h>
#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include <syslog.h>

#include "logging.h"
#include "crypto.h"
#include "passwd.h"
#include "paths.h"

extern char ClientHost[];

void
IDENTinitencrypt(name)
    char *name;
{
    FILE *f;

    f = fopen(_PATH_IDENTKEY, "r");
    if (!f)
        return;
    init_decryption(f);
    fclose(f);
}

/* use libident and identd to find out the name of a remote user (possibly
 * even if the remote ident server uses encryption)
 */
int
IDENTresolveuser(name, user, pass, args, ret, len)
    char *name, *user, *pass, *args, *ret;
    size_t len;
{
    char *idkey;
    char *iter;
    char buf[255];
    DBM *uids;
    datum d;

    idkey = ident_id(0,1);
    if (!idkey) {
        syslog(L_NOTICE, "can't contact remote ident server: %s", ClientHost);
        return(kPERMCantAuthenticate);
    } else if (*idkey == '[') {
        /* encrypted packet */
        if (!args) {
            syslog(L_NOTICE, "ident encrypted packet received, but no userid database");
            goto bad;
        }
        iter = strchr(idkey, ']');
        if (iter - idkey != 33) {
            syslog(L_NOTICE, "can't understand encrypted ident packet from %s",
              ClientHost);
            goto bad;
        }
        *iter = 0;
        iter = decrypt_packet(idkey+1);
        if (!iter) {
            syslog(L_ERROR, "could not decrypt ident packet from %s",
              ClientHost);
            goto bad;
        }
        uids = dbm_open(args, O_RDONLY, 0600);
        if (!uids) {
            syslog(L_ERROR, "could not open uid database %s", args);
            goto bad;
        }
        strcpy(buf, iter);
        d.dptr = buf;
        d.dsize = strlen(buf);
        d = dbm_fetch(uids, d);
        if (!d.dptr) {
            syslog(L_NOTICE, "uid %s not in userid database %s", buf, args);
            dbm_close(uids);
            goto bad;
        }
        strncpy(ret, d.dptr, d.dsize);
        ret[d.dsize] = 0;
        dbm_close(uids);
    } else
        strcpy(ret, idkey);
    free((void*)idkey);
    return(kPERMUserOK);
bad:
    free((void*)idkey);
    return(kPERMUserBad);
}
#endif //DO_AUTH_IDENT
