/*
**  Send file to the local server, clean up after deleted file.
*/

#define MAINLINE

/* a copied nnrpd.h */
#include "catchupnews.h"

#include <dirent.h>

#include "filter.h"
#include "notify.h"
#include "catchup.h"

extern FILT *curconn;

/* strip \r's from files */
void
Stripper(article)
    char *article;
{
    char *copyto = article;
    while (*article) {
        if (*article != '\r')
            *copyto++ = *article;
        article++;
    }
    *copyto = 0;
}

int
CUPsendfile(file)
    CUPent *file;
{
    FILE *art;
    long pos1, pos2;
    char *article;
    const char *error;
    char dir[255];

    art = fopen(file->fname, "r");
    if (!art)
        return(1);

    /* get the size of the file and suck the article in */
    pos1 = ftell(art);
    fseek(art, 0, SEEK_END);
    pos2 = ftell(art);
    article = (char*)malloc(pos2-pos1+1);
    if (!article) {
        fclose(art);
        unlink(file->fname);
        return(0);
    }
    rewind(art);
    fread(article, sizeof(char), pos2-pos1, art );
    fclose(art);
    article[pos2-pos1] = 0;
    Stripper(article);

    /* post the article */
    if (error = ARTpost(article,0)) {
        file->tries++;
        if (file->tries < 10) {
            free((void*)article);
            return(0);
        } else {
            FILTsetuser(curconn, file->user);
            ERRORseterror(curconn, error);
            CUPsetfilename(curconn, file->fname);
            NOTIFYsendmail(
              curconn,
              CONFkeywordvalue(FILTkeylist, "mail.error"),
              CONFkeywordvalue(FILTkeylist, "mail.error.text")
            );
        }
    }
    free((void*)article);

    return(1);
}
