#include "authfuncs.h"

#if	defined(DO_AUTH_PW) || defined(DO_AUTH_DB)

#include <pwd.h>
#include <stdio.h>
#include <string.h>
#include <ndbm.h>

#include <fcntl.h>

#include "passwd.h"

#if	defined(DO_AUTH_PW)
int file_getpwnam(const char*, const char*, char*);
#endif
#if	defined(DO_AUTH_DB)
int db_getpwnam(char*, char*, char*);
#endif

#if	defined(DO_AUTH_PW)
int
file_getpwnam(name, file, pass)
    const char *name, *file;
    char *pass;
{
   FILE *pwfile;
   char buf[255];
   char *colon, *iter;
   int found;

   pwfile = fopen(file, "r");
   if (!pwfile)
      return(1);
   found = 0;
   while ((!found) && fgets(buf, sizeof(buf), pwfile)) {
      buf[strlen(buf)-1] = 0; /* clean off the \n */
      if (!(colon = strchr(buf, ':'))) {
         fclose(pwfile);
         return(1);
      }
      *colon = 0;
      if (!strcmp(buf, name))
         found = 1;
   }
   fclose(pwfile);
   if (!found)
      return(1);
   iter = colon+1;
   if (!(colon = strchr(iter, ':')))
      return(1);
   *colon = 0;
   strcpy(pass, iter);
   return(0);
}
#endif //DO_AUTH_PW

#if	defined(DO_AUTH_DB)
int
db_getpwnam(name, file, pass)
    char *name, *file;
    char *pass;
{
    datum key;
    datum val;
    DBM *D;

    D = dbm_open(file, O_RDONLY, 0600);
    if (!D)
        return(1);
    key.dptr = name;
    key.dsize = strlen(name);
    val = dbm_fetch(D, key);
    if (!val.dptr) {
        dbm_close(D);
        return(1);
    }
    strncpy(pass, val.dptr, val.dsize);
    pass[val.dsize] = 0;
    dbm_close(D);
    return(0);
}
#endif //DO_AUTH_DB

int
PERMpwfile(name, user, pass, fname, realuser, len)
    char *name, *user, *pass, *fname, *realuser;
    size_t len;
{
    char buf[3];
#ifdef _AIX
    extern char *crypt(const char*, const char*);
#else
    extern char *crypt(char*, char*);
#endif
    char u_pass[64];

    if (!(user && name && pass && fname))
        return kPERMCantAuthenticate;
#if	defined(DO_AUTH_PW)
    if (!strcmp(name, "PW")) {
        if (file_getpwnam(user, fname, u_pass))
            return kPERMCantAuthenticate;
    }
#if	defined(DO_AUTH_DB)
    else
#endif	//DO_AUTH_DB
#endif	//DO_AUTH_PW
#if	defined(DO_AUTH_DB)
    if (!strcmp(name, "DB")) {
        if (db_getpwnam(user, fname, u_pass))
            return kPERMCantAuthenticate;
    }
#endif	//DO_AUTH_DB
    strncpy(buf, u_pass, 3);
    buf[2] = 0;
    if (strcmp(u_pass, crypt(pass, buf)))
        return kPERMCantAuthenticate;
    strncpy(realuser, user, len);
    return kPERMUserOK;
}
#endif	//DO_AUTH_PW || DO_AUTH_DB
