#include "authfuncs.h"

#if	defined(DO_AUTH_IPUSER)

#include "passwd.h"
#include "logging.h"
#include <fcntl.h>
#include <ndbm.h>

extern char ClientAddr[];

int
PERMipuser(inv, user, pass, args, ret, len)
    char *inv, *user, *pass, *args, *ret;
    size_t len;
{
    DBM *d;
    datum key, value;
    int retval;

    if ((!args) || (!*args)) {
        syslog(L_ERROR, "No arguments to IP-USER authentication.");
        return kPERMCantAuthenticate;
    }
    if (!*ClientAddr)
        return kPERMCantAuthenticate;
    d = dbm_open(args, O_RDONLY, 0660);
    if (!d) {
        syslog(L_ERROR, "Can't open IP->user database %s", args);
        return kPERMCantAuthenticate;
    }
    key.dptr = ClientAddr;
    key.dsize = strlen(ClientAddr);
    value = dbm_fetch(d, key);
    if (!value.dptr) {
        syslog(L_NOTICE, "IP %s not in IP->user database %s", ClientAddr,
          args);
        retval = kPERMCantAuthenticate;
    } else {
        strncpy(ret, value.dptr, value.dsize);
        ret[value.dsize] = 0;
        retval = kPERMUserOK;
    }
    dbm_close(d);
    return retval;
}
#endif	//defined(DO_AUTH_IPUSER)
