#ifndef __CONFIG_H
#define __CONFIG_H

typedef struct {} CONF;

typedef struct _CONFkeyword {
    char *keyword;
    char *value;
    int lineno;
    int used;
} CONFkeyword;

typedef int (*CONFloadfunc)(char*, char*, char*, CONF*);

typedef struct _CONFkeyload {
    char *name;
    CONFloadfunc func;
} CONFkeyload;

extern void CONFsetload(CONFkeyload*, int);

extern CONF *CONFload(char*);
extern void CONFfree(CONF*);
extern void CONFkeywordused(CONF*, char*);
extern char *CONFkeywordvalue(CONF*, char*);
extern CONF *CONFcheckkeywords(CONF*);

extern CONFkeyword *CONFfirstkey(CONF*);
extern CONFkeyword *CONFnextkey(CONF*, CONFkeyword*);

extern char *CONFfilename(CONF*);

#endif
