#!/usr/local/bin/perl

$prefix = ".";
$exec_prefix = "${prefix}";

if (open(LIB, "<${exec_prefix}/lib/libgizmo.pl")) {
    my (@cf_file) = <LIB>;
    my ($cf);
    $cf = join "", @cf_file;
    eval $cf || die "syntax error in ${exec_prefix}/lib/libgizmo.pl";
} else {
    die "couldn't read ${exec_prefix}/lib/libgizmo.pl";
}

if ($#ARGV != 1) {
    die "usage: $0 <username> <filename>";
}
$user = $ARGV[0];
$article_fname = $ARGV[1];

if (-f "$config_dir/gizmo.conf") {
    &load_config("$config_dir/gizmo.conf");
    $line = 0;
} else {
    die "no $config_dir/gizmo.conf";
}

&get_user;
$varhash = {};
for ($i = $#limit-1; $i >= 0; $i--) {
    $cp = [];
    $#$cp = -1;
    for ($j = 0; $j <= $#{$$config[$limit[$i+1]+1]}; $j++) {
	$$cp[$j] = $$config[$limit[$i+1]+1][$j];
    }
    &get_limit($cp, $varhash);
}

$#db_entries = -1;

$mail_msg = $$varhash{'Mail.err'};
if (!defined($mail_msg)) {
    # No way to send mail out for this.
    exit 0;
}

open(DBLOCK, "$state_dir/gizmo.lock");
flock(DBLOCK, LOCK_EX);

dbmopen(%post_db, "$state_dir/gizmo", 0644);
local ($ign1, $ign2, $hour, $ign4) = localtime(time);
if ($hour < 12) {
    $db_entries[0] = $post_db{"A-$ruser"};
    $db_entries[1] = $post_db{"P-$ruser"};
} else {
    $db_entries[1] = $post_db{"A-$ruser"};
    $db_entries[0] = $post_db{"P-$ruser"};
}
$static_entries = $post_db{"S-$ruser"};

dbmclose(%post_db);
flock(DBLOCK, LOCK_UN);
close(DBLOCK);

open(FNAME, "<$article_fname");
$first = 1;
while (<FNAME>) {
    chop;
    if ($first == 1) {
	$first = 0;
	if ($_ =~ /^[0-9]/) {
	    $errmsg = "$_\n";
	}
    }
    if ($_ !~ /:/) {
	while (<FNAME>) {
	    $body .= "$_";
	}
    } else {
	@line = split /:/,$_,2;
	$line[1] =~ s/^\s+(.*\S)\s*$/$1/;
	$hdr{$line[0]} = $line[1];
    }
}
&mail_message($varhash);
