#ifndef __GUCS_ERR_H
#define __GUCS_ERR_H

typedef struct _GUCS_error_type GUCS_error_type;

typedef void *(*GUCS_error_accessor_type)(GUCS_error_type *, char *, void *);
typedef void (*GUCS_error_cleanup_type)(GUCS_error_type *, char *, void *);

extern int gucs_err_init(void);

extern GUCS_error_type *gucs_err_alloc(void);

/* accessor functions for global error codes.  can't fail. */
extern GUCS_error_type *gucs_err_no_mem(void);
extern GUCS_error_type *gucs_err_usage(void);

/* allocate a new error type based on errno. */
extern GUCS_error_type *gucs_err_errno(int);

/* set the data associated with an error. */
extern GUCS_error_type *gucs_err_code_set(GUCS_error_type *, ...);
extern GUCS_error_type *gucs_err_data_set(GUCS_error_type *, char *,
                                          GUCS_error_accessor_type,
                                          GUCS_error_cleanup_type, void *);

extern GUCS_error_type *gucs_err_commit(GUCS_error_type *);

extern void gucs_err_ref(GUCS_error_type *);
extern void gucs_err_unref(GUCS_error_type *);

extern int gucs_error_code(GUCS_error_type *, int);
extern void *gucs_error_data(GUCS_error_type *, char *);

#endif
