#ifndef __FILTER_H
#define __FILTER_H

#include <sys/types.h>
#include <stdio.h>
#include "config.h"
#include "dep.h"

typedef struct _FILT {} FILT;

typedef void (*FILTdelfunc)(int, void*, size_t);

extern int FILTinit();
extern FILT *FILTconnect();
extern FILT *FILTalloc();
extern void FILTdestroy(FILT*);
extern char *FILTgetuser(FILT*);
extern void FILTsetuser(FILT*, char*);

extern void FILTlogmessage(FILT*, char*, char*, char*);

extern CONF *FILTkeylist;

/* access data associated with a FILT */

#define kFILTinttype	-1
#define kFILTstrtype	-2
#define kFILTfiletype	-3
#define kFILTfilttype	-4
#define kFILTdeptype	-5

extern int FILTadddata(FILT*, int, char*, void*, size_t);
extern void *FILTgetdata(FILT*, int, char*, size_t*);
extern int FILThasdata(FILT*, int, char*);
extern void FILTdeldata(FILT*, int, char*);

extern int FILTaddstring(FILT*, char*, char*);
extern char *FILTgetstring(FILT*, char*);
extern int FILThasstring(FILT*, char*);
extern void FILTdelstring(FILT*, char*);

extern int FILTaddint(FILT*, char*, int);
extern int FILTgetint(FILT*, char*);
extern int FILThasint(FILT*, char*);
extern void FILTdelint(FILT*, char*);

extern int FILTaddfile(FILT*, char*, char*, FILE*);
extern FILE *FILTgetfile(FILT*, char*);
extern char *FILTgetfname(FILT*, char*);
extern int FILThasfile(FILT*, char*);
extern int FILTisopenfile(FILT*, char*);
extern void FILTclosefile(FILT*, char*);
extern void FILTdelfile(FILT*, char*);

extern int FILTaddfilt(FILT*, char*, FILT*);
extern FILT *FILTgetfilt(FILT*, char*);
extern int FILThasfilt(FILT*, char*);
extern void FILTdelfilt(FILT*, char*);

extern int FILTadddep(FILT*, deplist*);
extern deplist *FILTgetdep(FILT*);

extern void FILTadddel(int, FILTdelfunc);

extern void FILTappend(FILT*, FILT*);

#endif
