#ifdef _AIX
#include <sys/file.h>
#endif

#include <stdio.h>
#include <ndbm.h>
#include <fcntl.h>

#include "filtpaths.h"

int main(argc, argv)
    int argc;
    char *argv[];
{
    char user[256], poststr[12];
    datum key;
    datum val;
    int fd;
    DBM *d;
    int numposts;

    if ((argc != 3)||
      ((argv[1][0]!='A')&&(argv[1][0]!='P')&&(argv[1][0]!='S'))||
      (argv[1][1]!='-')) {
        fprintf(stderr, "%s: Usage:\n", argv[0]);
        fprintf(stderr, "%s:\t<key> <numposts>\n", argv[0]);
        return(1);
    }
    strcpy(user, argv[1]);
    if ((fd = open(_PATH_POSTDB, O_RDWR)) == -1) {
        fprintf(stderr, "%s: couldn't open %s.\n", argv[0], _PATH_POSTDB);
        return(1);
    }
    lockfile(fd);
    if (!(d = dbm_open(_PATH_POSTDB, O_RDWR, 0660))) {
        unlockfile(fd);
        close(fd);
        fprintf(stderr, "%s: couldn't open DB %s\n", argv[0], _PATH_POSTDB);
        return(1);
    }
    key.dptr = user;
    key.dsize = strlen(user);
    val.dptr = argv[2];
    val.dsize = strlen(val.dptr);
    if (!val.dsize) {
        dbm_delete(d, key);
        printf("key %s deleted.\n", user);
    } else {
        dbm_store(d, key, val, DBM_REPLACE);
        printf("key %s posted %s times.\n", user, argv[2]);
    }
    dbm_close(d);
    unlockfile(fd);
    close(fd);
    return(0);
}
