#include <string.h>
#include <ctype.h>
#include "filter.h"
#include "proto.h"

static FILTheadproc headproc = 0;
static char *head = 0;
static int size = 0;

void
FILTaddheader(filt, name, value)
    FILT *filt;
    char *name, *value;
{
    int length;
    FILT *foo;

    if (name != head) {
        length = strlen(name)+1;
        if (length > size) {
            head = (char*)realloc(head, length);
            size = length;
        }
        for (length = 0; name[length] && name[length] != ':'; length++)
            head[length] = tolower(name[length]);
        head[length] = 0;
    }
    foo = FILTgetfilt(filt, "msg.headers");
    if (!foo) {
        foo = FILTalloc();
        FILTaddfilt(filt, "msg.headers", foo);
    }
    FILTaddstring(foo, head, value);
}

char *
FILTgetheader(filt, name)
    FILT *filt;
    char *name;
{
    FILT *foo;
    int length;

    length = strlen(name)+1;
    if (length > size) {
        head = (char*)realloc(head, length);
        size = length;
    }
    for (length = 0; name[length] && name[length] != ':'; length++)
        head[length] = tolower(name[length]);
    head[length] = 0;

    foo = FILTgetfilt(filt, "msg.headers");
    if (!foo) {
        foo = FILTalloc();
        FILTaddfilt(filt, "msg.headers", foo);
    }

    if (!FILTgetstring(foo, head) && headproc)
        headproc(filt, head);
    return(FILTgetstring(foo, head));
}

void
FILTclearheaders(filt)
    FILT *filt;
{
    FILTdelfilt(filt, "msg.headers");
}

void
FILTsetheadproc(proc)
    FILTheadproc proc;
{
    headproc = proc;
}
