#include <stdio.h>
#include <unistd.h>
#include "filter.h"
#include "error.h"
#include "substfuncs.h"
#include "proto.h"
#include "catchup.h"

void
ERRORseterror(filt, newerr)
    FILT *filt;
    char *newerr;
{
    FILTaddstring(filt, "priv.error", newerr);
}

void
ERRORclearerror(filt)
    FILT *filt;
{
    FILTdelstring(filt, "priv.error");
}

void
SUBSTgeterror(name, ret, len, parm)
    char *name, *ret;
    size_t len;
    FILT *parm;
{
    char *str = FILTgetstring(parm, "priv.error");

    if (!str)
        *ret = 0;
    else
        strncpy(ret, str, len);
}

void
SUBSTfilename(arg, ret, len, parm)
    char *arg;
    char *ret;
    size_t len;
    FILT *parm;
{
    char *curfile = CUPgetfilename(parm);

    if (!curfile) {
        *ret = 0;
        return;
    }
    strncpy(ret, curfile, len);
    ret[len-1] = 0;
}

void
SUBSTfiletext(arg, ret, len, parm)
    char *arg;
    char *ret;
    size_t len;
    FILT *parm;
{
    FILE *f;
    char *curfile = CUPgetfilename(parm);

    if (!curfile) {
        *ret = 0;
        return;
    }
    f = fopen(curfile, "r");
    if (!f) {
        *ret = 0;
        return;
    }
    fread((void*)ret, 1, len, f);
    fclose(f);
}

size_t
SUBSTfilelen(arg, parm)
    char *arg;
    FILT *parm;
{
    FILE *f;
    size_t start, end;
    char *curfile = CUPgetfilename(parm);

    if (!curfile)
        return(0);
    f = fopen(curfile, "r");
    if (!f)
        return(0);
    fseek(f, 0, SEEK_SET);
    start = ftell(f);
    fseek(f, 0, SEEK_END);
    end = ftell(f);
    fclose(f);
    return(end-start);
}

void
SUBSTusername(arg, ret, len, parm)
    char *arg, *ret;
    size_t len;
    FILT *parm;
{
    char *user;

    if (user=FILTgetuser(parm))
        strncpy(ret, user, len);
    else
        *ret=0;
}
