#include <sys/types.h>
#include <sys/select.h>
#include <unistd.h>
#include <stdio.h>

#include <filter.h>
#include <misc.h>
#include <proto.h>

FILT *curuser;

int
main(argc, argv)
    int argc;
    char *argv[];
{
    if (FILTinit())
	return(1);
    while (1) {
	curuser = FILTconnect();
	get_data();
	get_art();
	process_art();
	FILTdestroy(curuser);
    }
    return(0);
}

void
get_data(void)
{
    int got_blank = 0;
    char buf[256];
    char *username;

    while (!got_blank) {
	if (!fgets(buf, sizeof(buf), stdin))
	    exit(1);
	strip_eoln(buf);
	if (!*buf)
	    got_blank = 1;
	else {
	    if (!strncasecmp(buf, "username:", 9)) {
		username = buf+9;
		while (*username && isspace(*username))
		    username++;
		if (*username)
		    FILTsetuser(curuser, username);
	    }
	}
    }
}

void
get_art()
{
    int inheader, inbody;
    char buf[1024];
    char *iter;

    inheader = 1;
    while (inheader) {
	if (!fgets(buf, sizeof(buf), stdin))
	    exit(1);
	strip_eoln(buf);
	if (!*buf)
	    inheader = 0;
	else {
	    iter = strchr(buf, ':') + 1;
	    if (!*iter)
		continue;
	    *iter++ = 0;
	    while (*iter && isspace(*iter))
		iter++;
	    FILTaddheader(curuser, buf, iter);
	}
    }
    inbody = 1;
    while (inbody) {
	if (!fgets(buf, sizeof(buf), stdin))
	    exit(1);
	strip_eoln(buf);
	if (!strcmp(buf, "."))
	    inbody = 0;
    }
}

void
process_art()
{
    LIMtrackpost(curuser);
    if (FILTgetfile(curuser, sMSGlog))
	FILTclosefile(curuser, sMSGlog);
    if (!LIMshouldsend(curuser)) {
	fprintf(stdout, "435\r\n");
	fflush(stdout);
    } else {
	fprintf(stdout, "235\r\n.\r\n");
	fflush(stdout);
    }
    LIMfinish(curuser);
}

void
strip_eoln(buf)
    char *buf;
{
    char *i = &buf[strlen(buf)-1];

    if (*i != '\n')
	return;
    *i-- = 0;
    if (*i != '\r')
	return;
    *i-- = 0;
}
