#include <stdio.h>
#include <string.h>
#include <sys/types.h>

static char ls_username[256];
static int found=0;

char *
ls_user_from_uid(uid, nouser)
    uid_t uid;
    int nouser;
{
    char buf[255];
    char *iter, *colon;
    FILE *f;
    int index;

    if (!found) {
        if (!(f=fopen("/etc/passwd", "r"))) {
            found = 2;
            goto done;
        }
        sprintf(ls_username, "%d", uid);
        while (!found && (fgets(buf, sizeof(buf), f))) {
            /* prevent buffer overruns */
            buf[sizeof(buf)-1] = 0;
            /* strip off \n */
            buf[strlen(buf)-1] = 0;
            if (!*buf)
                continue;
            index = 2;
            iter = buf;
            while (index--)
                if (!(iter = strchr(iter+1,':')))
                    continue;
            iter++;
            colon = strchr(iter, ':');
            *colon = 0;
            if (!strcmp(iter, ls_username)) {
                colon = strchr(buf, ':');
                *colon = 0;
                strcpy(ls_username, buf);
                found = 1;
            }
        }
        fclose(f);
        if (!found)
            found = 2;
    }
done:
    if (nouser && (found != 1))
        return (0l);
    return(ls_username);
}
